
public class GameLogic {

	public static void nextGeneration(Grid matrix) {

		// Create a temporary grid
		Grid temp = new Grid(matrix.numRows(), matrix.numCols());

                // Iterate through each cell to determine the status of each
                // cell for the next generation: for each case with the
                // specified number of neighbors, set the cell in the temporary
                // grid to be either alive or dead (1 or 0).

		for (int row = 0; (row < matrix.numRows()); row++) {
			for (int col = 0; (col < matrix.numCols()); col++) {
				switch (matrix.countNeighbors(row, col)) {
				case 0:
				case 1:
					temp.setLifeAt(row, col, 0);
					break;
				case 2:
					temp.setLifeAt(row, col, matrix.lifeAt(row, col));
					break;
				case 3:
					temp.setLifeAt(row, col, 1);
					break;
				case 4:
				case 5:
				case 6:
				case 7:
				case 8:
					temp.setLifeAt(row, col, 0);
					break;
				}
			}
		}

		// Copy all the the temporary matrix to the real matrix
		for (int row = 0; (row < matrix.numRows()); row++) {
			for (int col = 0; (col < matrix.numCols()); col++) {
				matrix.setLifeAt(row, col, temp.lifeAt(row, col));
			}
		}

	}
	
}

